mod Mtexpr

incl Mtex

rem 
  \para \bf  Universal Function for Primitive Recursive Functions.  \end 

rem 
  \para \it  Arithmetization of primitive recursive function symbols.  \end 

appldisp/0 Tex_f0_pr_zx
  Id(3,'Z',0)

appldisp/0 Tex_f0_pr_sx
  Id(3,'S',0)

appldisp/2 Tex_f2_pr_px
  Fenced(Id(2,Ent('lang'),0),Infix(Arg(0),25,0,Id(2,',',0),Arg(1)),Id(2,Ent('rang'),0))

appldisp/2 Tex_f2_pr_ix
  Subsup(Id(3,'I',0),75,Arg(1),Arg(0))

appldisp/4 Tex_f4_pr_cx
  Prefix(70,0,Subsup(Id(3,'Comp',0),75,Arg(1),Arg(0)),
         Fenced(Op('(',0),Infix(Arg(2),40,0,Op(',',0),Arg(3)),Op(')',0)))

appldisp/3 Tex_f3_pr_rx
  Prefix(70,0,Subsup(Id(3,'Rec',0),75,Arg(0),None),
         Fenced(Op('(',0),Infix(Arg(1),40,0,Op(',',0),Arg(2)),Op(')',0)))

rem 
  \para \it  Interpeter of primitive recursive functions.  \end 

appldisp/3 Tex_f3_pr_sel
  Subsup(Fenced(Op('[',0),Arg(1),Op(']',0)),75,Arg(2),Arg(0))

appldisp/2 Tex_f2_pr_u
  Infix(Arg(0),50,2,Op(Ent('bull'),0),Arg(1))

rem 
  \para \it  Arithmetization of primitive recursive terms.  \end 

appldisp/1 Tex_f1_pr_vt
  Subsup(Id(3,'x',0),75,Arg(0),Op(Ent('bull'),0))

appldisp/1 Tex_f1_pr_ct
  Subsup(Arg(0),75,None,Op(Ent('bull'),0))

appldisp/2 Tex_f2_pr_pt
  Fenced(Id(2,Ent('lang'),0),Infix(Arg(0),25,0,Id(2,',',0),Arg(1)),Id(2,Ent('rang'),0))

appldisp/2 Tex_f2_pr_at
  Prefix(70,0,Arg(0),Fenced(Id(2,'(',0),Arg(1),Id(2,')',0)))

appldisp/3 Tex_f3_pr_den
  Subsup(Fenced(Op(Ent('lobrk'),0),
                Prefix(100,2,Arg(1),
                       Fenced(Op('[',0),
                              Infix(Subsup(Id(1,'x',0),75,Num('1',0),None),20,0,
                                    Id(1,',...,',0),
                                    Subsup(Id(1,'x',0),75,Arg(0),None)),Op(']',0))),
                Op(Ent('robrk'),0)),75,Arg(2),None)

rem 
  \para \it  Examples of primitive recursive indices.  \end 

appldisp/0 Tex_f0_pr_xc1_1
  Subsup(Id(3,'C',0),75,Num('1',0),None)

appldisp/0 Tex_f0_pr_xc1_2
  Subsup(Id(3,'C',0),75,Num('2',0),None)

appldisp/0 Tex_f0_pr_xc1_3
  Subsup(Id(3,'C',0),75,Num('3',0),None)

appldisp/0 Tex_f0_pr_xc1_4
  Subsup(Id(3,'C',0),75,Num('4',0),None)

appldisp/0 Tex_f0_pr_xc1_256
  Subsup(Id(3,'C',0),75,Num('256',0),None)

appldisp/0 Tex_f0_pr_xplus
  Id(3,'Plus',0)

appldisp/0 Tex_f0_pr_xpred
  Id(3,'Pred',0)

appldisp/0 Tex_f0_pr_xminus
  Id(3,'Minus',0)

appldisp/0 Tex_f0_pr_xtimes
  Id(3,'Times',0)

appldisp/0 Tex_f0_pr_xexp
  Id(3,'Exp',0)

rem 
  \para \it  Operations on p.r. indices.  \end 

appldisp/1 Tex_f1_pr_xc1
  Subsup(Id(3,'C',0),75,Arg(0),None)

appldisp/2 Tex_f2_pr_xc2
  Subsup(Id(3,'C',0),75,Arg(1),Arg(0))

appldisp/2 Tex_f2_pr_xedf
  Infix(Subsup(Id(7,Ent('lambda'),0),75,Arg(0),None),40,0,Op('.',0),Arg(1))

appldisp/1 Tex_f1_pr_xiter
  Prefix(100,2,Id(3,'Iter',0),Arg(0))

appldisp/2 Tex_f2_pr_xrec0
  Prefix(70,0,Id(3,'Rec0',0),
         Fenced(Op('(',0),Infix(Arg(0),40,0,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex_f2_pr_xparam
  Infix(Arg(0),39,1,Id(3,'/',0),Arg(1))

rem 
  \para \it  Some macros.  \end 

fun/0 Texm_f0_dotsc 'Tex0_dotsc'
  Texm_f0_dotsc = 0

fun/2 Texm_f2_sub 'Tex2_sub'
  Texm_f2_sub(x,y) = 0

fun/3 Texm_f3_subst_dotsc 'Tex_f3_subst_dotsc'
  Texm_f3_subst_dotsc(t,x,y) = 0

fun/0 Texm_f0_f 'Tex_f0_f'
  Texm_f0_f = 0

rem 
  \para \it  Self-reproducing machine.  \end 

appldisp/0 Tex_f0_pr_xpair
  Id(3,'Pair',0)

appldisp/0 Tex_f0_pr_xg
  Id(3,'g',0)

appldisp/0 Tex_f0_pr_xself
  Id(3,'Self-reproducing machine',0)

